CDECK  ID>, CHEVNT.
*CMZ :-        -17/07/03  18.11.30  by  Peter Richardson
*-- Author :    Chris Harris
C----------------------------------------------------------------------
      SUBROUTINE CHEVNT(GENEVT)
C----------------------------------------------------------------------
C     Black Hole Production and Decay
C----------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE 'charybdis1003.inc'
C--Les Houches run common block
      INTEGER MAXPUP
      PARAMETER(MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON /HEPRUP/ IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &                IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &                XMAXUP(MAXPUP),LPRUP(MAXPUP)
C--event common block
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &              IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &              ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &              SPINUP(MAXNUP)
C--Local Variables
      DOUBLE PRECISION ECMS,ONE,TWO,PIFAC,THREE,ZERO,
     &     CHRGEN,RPOW,A0,A1,EMJ,FACT,QSQ,HCS,PROB,
     &     FACTR,RCS,BHPOW,DISF1,DISF2,OMEGAD,DL2GT,PSTEST,
     &     RHORSQ,PLPOW,MPFACT,PA(5),PB(5),PC(5),PCM,CHUPCM,PCMF(5),
     &     XXMIN,XLMIN,EMSCA,XX(2),DISF(13,2),GEV2PB,CHFMAS,YRF(7)
      INTEGER STAT,IBARYN,IQRK(MAXPUP),IGLU(MAXPUP),IQBR(MAXPUP),MTRY,
     &     NQRK,NGLU,NQBR,JQRK,JGLU,JQBR,J,ISTART,CHST,iline,FSTAT(5),
     &     IP,IQ,PT,I,BHCHRG,IDN(2),NTRY,NHTRY,SAVCHR,SAVBRN,ID(5),
     &     MHTRY,LTRY,LHTRY,CHFCHG,SPIN,FSPIN(5)
      LOGICAL GENEVT,CHRLOG,FIRST,OKDEC
      EXTERNAL CHFMAS,CHRGEN,CHUPCM,CHRLOG,CHFCHG
      PARAMETER(ONE=1.0D0,TWO=2.0D0,THREE=3.0D0,ZERO=0.0D0,NHTRY=200)
      PARAMETER(MHTRY=20,LHTRY=200,GEV2PB=389379.D3)
      SAVE HCS,BHPOW,PLPOW,RPOW,A0,A1,FACT,MPFACT
      DATA FIRST/.TRUE./
C--BW mod 16/08/06: Yoshino-Rychkov factors for cross section,
C  from Phys.Rev.D71:104028,2005 [hep-th/0503171]
      DATA YRF/1.54,2.15,2.52,2.77,2.95,3.09,3.20/
C--end mod
      PIFAC = ACOS(-ONE)
      IF(FIRST) THEN
C--Convert MPLNCK to M_GT if above value is M_DL
         IF (MSSDEF.EQ.2) THEN
            DL2GT=(TWO**(TOTDIM-6)*PIFAC**(TOTDIM-5))**(1/(TOTDIM-TWO))
            INTMPL=DL2GT*MPLNCK
C--Convert MPLNCK to M_GT if above value is M_D
         ELSEIF (MSSDEF.EQ.3) THEN
            INTMPL=MPLNCK*TWO**(1/(TOTDIM-TWO))
         ELSE
            INTMPL=MPLNCK
         ENDIF
C--Calculate other parameters
         PLPOW=TWO/(TOTDIM-THREE)
         BHPOW=PLPOW-7.0D0
         RPOW=1/BHPOW
         A0=MINMSS**BHPOW
         A1=(MAXMSS**BHPOW-A0)
         IF (TOTDIM.EQ.11) THEN
            OMEGAD=(PIFAC**5)/12
         ELSEIF (TOTDIM.EQ.10) THEN
            OMEGAD=(32*PIFAC**4)/105
         ELSEIF (TOTDIM.EQ.9) THEN
            OMEGAD=(PIFAC**4)/3
         ELSEIF (TOTDIM.EQ.8) THEN
            OMEGAD=(16*PIFAC**3)/15
         ELSEIF (TOTDIM.EQ.7) THEN
            OMEGAD=PIFAC**3
         ELSEIF(TOTDIM.EQ.6) THEN
            OMEGAD=(8*PIFAC**2)/3
         ELSE
            OMEGAD=1
         ENDIF
         MPFACT=INTMPL**(TOTDIM-2)
         RHFACT=(4*(2*PIFAC)**(TOTDIM-4))/((TOTDIM-2)*OMEGAD*MPFACT)
         FIRST = .FALSE.
      ENDIF      
C--Select a mass for the produced black hole
      ECMS = 2.0D0*SQRT(EBMUP(1)*EBMUP(2))
      EMSCA=(A0+A1*CHRGEN(1))**RPOW
      BHMASS=EMSCA
      QSQ=EMSCA**2
      EMJ=EMSCA**(1-BHPOW)/BHPOW*A1
C--Calculate (r_h)**2 and initial T_H
      RHORSQ=(RHFACT*EMSCA)**PLPOW
C--Select initial momentum fractions
      XXMIN=QSQ/ECMS**2
      XLMIN=LOG(XXMIN)
      FACT=-GEV2PB*PIFAC*RHORSQ*EMJ*XLMIN*TWO/EMSCA
C--BW mod 16/08/06: include Yoshino-Rychkov factor
      IF (YRCSEC) FACT=FACT*YRF(TOTDIM-4)
C--end mod
C--Change momentum scale for calling pdfs (see comment above)
      IF (GTSCA) EMSCA=1/SQRT(RHORSQ)
      SCALUP = EMSCA
      CALL CHPDF(XXMIN,XLMIN,EMSCA,XX,DISF)
      HCS=ZERO
      DISF1=ZERO
      DISF2=ZERO
      DO 30 IP=1,13
      DISF1=DISF1+DISF(IP,1)
 30   DISF2=DISF2+DISF(IP,2)
      FACTR=FACT*DISF1*DISF2
      HCS=FACTR
      XWGTUP = HCS
      IF(.NOT.GENEVT) RETURN
      RCS=HCS*CHRGEN(0)
      HCS = 0.0D0
      DO 20 IP=1,13
      DO 10 IQ=1,13
      FACTR=FACT*DISF(IP,1)*DISF(IQ,2)
      HCS=HCS+FACTR
      IF (HCS.GT.RCS) GOTO 99
 10   CONTINUE
 20   CONTINUE
C--Generate event
 99   IDN(1)=IP
      IDN(2)=IQ
C--put the incoming particles in the Les Houches common block
      NUP = 2
      DO I=1,2
         IF(IDN(I).GT.6.AND.IDN(I).LE.12) THEN
            IDN(I) = -MOD(IDN(I)-1,6)-1
         ELSEIF(IDN(I).EQ.13) THEN
            IDN(I) = 21
         ENDIF
         IDUP(I) = IDN(I)
         PUP(1,I) = 0.0D0
         PUP(2,I) = 0.0D0
         PUP(3,I) = XX(I)*EBMUP(I)
         PUP(4,I) = XX(I)*EBMUP(I)
         ISTUP(I) = -1
      ENDDO
      PUP(3,2) = -PUP(3,2)
      CALL CHVSUM(4,PUP(1,1),PUP(1,2),PCMF)
      CALL CHUMAS(PCMF)
C--Calculate BH charge (actually 3*charge)
      BHCHRG=CHFCHG(IDN(1))+CHFCHG(IDN(2))
C--Black Hole decay
      MTRY = 0
      CHST = BHCHRG
 35   MTRY = MTRY+1
      BHCHRG = CHST
      NUP = 2
      CALL CHVEQU(5,PCMF,PA)
 40   NUP = NUP+1
C--BW mod 16/08/06: allow BH mass down to RMMINM
C--Check that BH mass > RMMINM if not using KINCUT      
      IF ((.NOT.KINCUT).AND.(PA(5).LT.RMMINM)) GOTO 55
C--end mod
C--Set BHMASS to correct value (necessary in time varying case)
      IF (TIMVAR) BHMASS=PA(5)
C--Select the decay product
      LTRY=0
 45   IF (MSSDEC.EQ.1) THEN
         CALL CHHBH1(PT,STAT,SPIN,BHCHRG)
      ELSEIF (MSSDEC.EQ.2) THEN
         CALL CHHBH2(PT,STAT,SPIN,BHCHRG)
      ELSE
         CALL CHHBH3(PT,STAT,SPIN,BHCHRG)
      ENDIF
C--Obtain energy of emitted parton
      CALL CHUBHS(PC(4),STAT,SPIN)
      PC(5)=CHFMAS(PT)
C--Check energy > mass for selected parton
      IF (PC(4).LT.PC(5)) THEN
         BHCHRG=BHCHRG+CHFCHG(PT)
         IF(IBHPRN.EQ.2) WRITE (*,*) 'Not enough energy'
         GOTO 45
      ENDIF
C--Check that emission is kinematically allowed
      IF (PC(4).GT.(PA(5)**2+PC(5)**2)/(TWO*PA(5))) THEN
         IF (KINCUT.OR.LTRY.GT.LHTRY) THEN 
            GOTO 50
         ELSE
            LTRY=LTRY+1
            BHCHRG=BHCHRG+CHFCHG(PT)
            GOTO 45
         ENDIF
      ENDIF
C--Use 2-body phase space decay 
      PB(5)=SQRT(PA(5)**2+PC(5)**2-TWO*PA(5)*PC(4))
C--Calculate centre of mass momentum for decay
      PCM=SQRT(PC(4)**2-PC(5)**2)
C--PA is BH 5-momentum before, PB after decay
      CALL CHDTWO(PA,PB,PC,PCM,TWO,.TRUE.)
C--Add emitted particle to event record
      CALL CHVEQU(5,PC,PUP(1,NUP))
      IDUP(NUP)=PT
      ISTUP(NUP) = 1
      MOTHUP(1,NUP) = 1
      MOTHUP(2,NUP) = 2
C--Change BH 5-momentum back to PA
      CALL CHVEQU(5,PB,PA)
      GOTO 40
 50   BHCHRG=BHCHRG+CHFCHG(PT)
 55   NUP = NUP-1
C--Calculate the baryon number violation
C--Find the baryon number of the inital state
      IBARYN = 0
      DO I=1,2
        IF(ABS(IDUP(I)).LE.6) IBARYN = IBARYN-SIGN(1,IDUP(I))
      ENDDO
C--and the final state
      DO I=3,NUP
        IF(ABS(IDUP(I)).LE.6) IBARYN = IBARYN+SIGN(1,IDUP(I))
      ENDDO
C--Try to balance this out
      NTRY = 0
      SAVCHR = BHCHRG
      SAVBRN = IBARYN
 60   NTRY = NTRY+1
      PCM = PA(5)
      DO I=1,NBODY
         IF (MSSDEC.EQ.1) THEN
            CALL CHHBH1(ID(I),FSTAT(I),FSPIN(I),BHCHRG)
         ELSEIF (MSSDEC.EQ.2) THEN
            CALL CHHBH2(ID(I),FSTAT(I),FSPIN(I),BHCHRG)
         ELSE
            CALL CHHBH3(ID(I),FSTAT(I),FSPIN(I),BHCHRG)
         ENDIF
         IF(ABS(ID(I)).LE.6) THEN
            IBARYN = IBARYN+SIGN(1,ID(I))
         ENDIF
         PCM = PCM-CHFMAS(ID(I))
      ENDDO
      IF(((IBARYN.NE.0.OR.BHCHRG.NE.0).OR.
     &    PCM.LT.0.0D0).AND.NTRY.LE.NHTRY) THEN
         BHCHRG = SAVCHR
         IBARYN = SAVBRN
         GOTO 60
      ENDIF
C--Go back if needed
      IF(NTRY.GT.NHTRY) THEN
         IF(MTRY.LE.MHTRY) THEN
            IF(IBHPRN.EQ.2) THEN
               WRITE (*,*) 'Attempt',MTRY,' failed.'
               WRITE (*,*) 'Starting whole decay again'
            ENDIF
            GOTO 35
         ELSE
            IF(IBHPRN.GT.1) 
     &           PRINT *,'WARNING TOO MANY TRIES NEEDED'
            XWGTUP = 0.0D0
            RETURN
         ENDIF
      ENDIF
C--Perform the NBODY decay of the remnant
C--BW mod 18/08/06: check if there is phase space
      PSTEST=PA(5)
      DO I=1,NBODY
         PUP(5,NUP+I) = CHFMAS(ID(I))
         PSTEST=PSTEST-PUP(5,NUP+I)
         ISTUP(NUP+I) = 1
         IDUP(NUP+I) = ID(I)
         MOTHUP(1,NUP+I) = 1
         MOTHUP(2,NUP+I) = 2
      ENDDO
C--check if decay is allowed
      IF (PSTEST.LE.0D0) GOTO 100
      OKDEC=.TRUE.
C--end mod
      IF (NBODY.EQ.2) THEN
         PCM = CHUPCM(PA(5),PUP(5,NUP+1),PUP(5,NUP+2))
         CALL CHDTWO(PA,PUP(1,NUP+1),PUP(1,NUP+2),PCM,TWO,.TRUE.)
      ELSEIF (NBODY.EQ.3) THEN
         CALL CHDTHR(PA,PUP(1,NUP+1),PUP(1,NUP+2),PUP(1,NUP+3),OKDEC)
      ELSEIF (NBODY.EQ.4) THEN
         CALL CHDFOR(PA,PUP(1,NUP+1),PUP(1,NUP+2),PUP(1,NUP+3),
     &                  PUP(1,NUP+4),OKDEC)
      ELSEIF (NBODY.EQ.5) THEN
         CALL CHDFIV(PA,PUP(1,NUP+1),PUP(1,NUP+2),PUP(1,NUP+3),
     &                  PUP(1,NUP+4),PUP(1,NUP+5),OKDEC)
      ENDIF
      IF (OKDEC) GOTO 110
 100  IF(IBHPRN.GE.1) 
     &     PRINT *,'FAILED',NBODY,'-BODY REMNANT DECAY: M,Q=',
     &     PA(5),PSTEST
      GOTO 35
 110  NUP = NUP+NBODY
C--Now sort out the colour connections
C--First the initial state
      NQRK = 0
      NGLU = 0
      NQBR = 0
      DO I=1,2
        IF(IDUP(I).GT.0.AND.IDUP(I).LE.6) THEN
           NQBR = NQBR+1
           IQBR(NQBR) = I
        ELSEIF(IDUP(I).LT.0.AND.IDUP(I).GE.-6) THEN
           NQRK = NQRK+1
           IQRK(NQRK) = I
        ELSEIF(IDUP(I).EQ.21) THEN
           NGLU = NGLU+1
           IGLU(NGLU) = I
        ENDIF
      ENDDO
C--Then the final state
      DO I=3,NUP
        IF(IDUP(I).GT.0.AND.IDUP(I).LE.6) THEN
           NQRK = NQRK+1
           IQRK(NQRK) = I
        ELSEIF(IDUP(I).LT.0.AND.IDUP(I).GE.-6) THEN
           NQBR = NQBR+1
           IQBR(NQBR) = I
        ELSEIF(IDUP(I).EQ.21) THEN
           NGLU = NGLU+1
           IGLU(NGLU) = I
        ENDIF
      ENDDO
C--zero the colour connections
      DO I=1,NUP
         DO J=1,2
            ICOLUP(J,I) = 0
         ENDDO
      ENDDO
C--Now make the colour connections
      JGLU = 0
      JQBR = 0
      JQRK = 0
      IF(NQRK.GT.0) THEN 
         I = IQRK(1)
         JQRK = 1
         J = 1
      ELSEIF(NGLU.GT.0) THEN
         I = IGLU(1)
         JGLU = 1
         J = 2
      ELSE
         GOTO 200
      ENDIF
      ISTART = I
      ILINE  = 500
C--Find an antiquark or gluon to pair this with
 150   IF(J.EQ.1.OR.J.EQ.2) THEN
         IF(JQBR.EQ.NQBR.and.JGLU.EQ.NGLU) THEN
            GOTO 250
         ELSE
            PROB = DBLE(NQBR-JQBR)/DBLE(NQBR+NGLU-JQBR-JGLU)
C--Pair with an antiquark
            IF(CHRLOG(PROB)) THEN
               IF(JQBR.NE.NQBR) THEN
                 IF(NGLU.NE.JGLU.and.NQBR-JQBR.EQ.1) GOTO 150
                  JQBR = JQBR+1
                  IF(I.LE.2) THEN
                     ICOLUP(2,I         ) = ILINE
                  ELSE
                     ICOLUP(1,I         ) = ILINE
                  ENDIF
                  IF(IQBR(JQBR).LE.2) THEN
                     ICOLUP(1,IQBR(JQBR)) = ILINE
                  ELSE
                     ICOLUP(2,IQBR(JQBR)) = ILINE
                  ENDIF
                  ILINE = ILINE+1
                  I = IQBR(JQBR)
                  J = 3
                  GOTO 150
               ELSE
                  GOTO 250
               ENDIF
C--Pair with a gluon
            ELSE
               IF(JGLU.NE.NGLU) THEN
                  JGLU = JGLU+1
                  IF(I.LE.2) THEN
                     ICOLUP(2,I         ) = ILINE 
                  ELSE
                     ICOLUP(1,I         ) = ILINE 
                  ENDIF
                  IF(IGLU(JGLU).LE.2) THEN
                     ICOLUP(1,IGLU(JGLU)) = ILINE
                  ELSE
                     ICOLUP(2,IGLU(JGLU)) = ILINE
                  ENDIF
                  ILINE = ILINE+1
                  I = IGLU(JGLU)
                  J = 2
                  GOTO 150
               ELSE
                  GOTO 250
               ENDIF
            ENDIF
         ENDIF
C--Find a quark to pair this with
      ELSEIF(J.EQ.3) THEN
         IF(JQRK.NE.NQRK) THEN
            JQRK = JQRK+1
            IF(I.LE.2) THEN
               ICOLUP(2,I         ) = ILINE
            ELSE
               ICOLUP(1,I         ) = ILINE
            ENDIF
            IF(IQRK(JQRK).LE.2) THEN
               ICOLUP(1,IQRK(JQRK)) = ILINE
            ELSE
               ICOLUP(2,IQRK(JQRK)) = ILINE
            ENDIF
            ILINE = ILINE+1
            I = IQRK(JQRK)
            J = 1
            GOTO 150
         ELSE
            GOTO 250
         ENDIF
      ENDIF
 250  IF(I.LE.2) THEN
         ICOLUP(2,I)      = ILINE
      ELSE
         ICOLUP(1,I)      = ILINE
      ENDIF
      IF(ISTART.LE.2) THEN
         ICOLUP(1,ISTART) = ILINE
      ELSE
         ICOLUP(2,ISTART) = ILINE
      ENDIF
C--zero the flavours
 200  DO I=1,NUP
         IF(IDUP(I).GT.0.AND.IDUP(I).LE.6) THEN
            ICOLUP(2,I) = 0
         ELSEIF(IDUP(I).GE.-6.AND.IDUP(I).lt.0) THEN
            ICOLUP(1,I) = 0
         ELSEIF(IDUP(I).NE.21) THEN
            ICOLUP(1,I) = 0
            ICOLUP(2,I) = 0
         ENDIF
      ENDDO
      END
